unit RTPunit;
{$E-,N+,F+}
interface
uses Dos,Crt,spcommon;
const
    RTPbyteSize=32768;
    measSize   =1024;
    BufSize    =RTPbyteSize+10*measSize;
    RTPmmmSize =16375;
    RTPwordSize=RTPbyteSize div 2;
    dataSize   =BufSize div 2;
    data2size  =dataSize div 2;
    ind1ofmeas =1-((RTPbyteSize div 2) div measSize);
    DMMSize    =1024;

    ON=1;
    OFF=0;


type
    com=(SSC,DRIVE,SFIX,LPS,SSHUT,HOLD,OFFLINE,SENC,SCR,SFR,SPR,SXR,SYR,
         GXY,GXYC,GFOG,SFROM,STO,SLCN,SAL,SLMAX,SLMIN,SLPM,SLFOG,SANOR,
         SAPM,SA,SNC,SNF,SNS,SAVE,LSC,LA,LERROR,LLCN,DMM,MMM,XT,LDARK,LI);

var
    RTPbyte  :array[1..BufSize]of byte;
    RTPword  :array[1..RTPwordSize]of integer absolute RTPbyte;
    RTPmmm   :array[-8..RTPmmmSize]of byte absolute RTPbyte;
    meas     :array[ind1ofmeas..5,1..measSize] of integer absolute RTPbyte;
    data     :array[1..dataSize] of integer absolute RTPbyte;
    data2    :array[1..2,1..data2size] of integer absolute RTPbyte;
    nsig     :array[1..5] of longint;
    reg      :registers;
    RTPinit  :boolean;
    slittype :integer;
    measfile,measfile2:file;

    cfile:text;
    cfname:string[60];
    rok,mes,den,dent,hour,minute,sec,sec100:word;
    srec:searchrec;
    sss:string[5];


procedure RTP(comcode :com;par1:integer;var par2,par3:longint;
                                             var err:integer);
procedure XtPlot(filename:string;i1,i2:longint;disp:integer);
{-------------------------------------------------------------------------}

implementation

var measfilename: string[12];

{-------------------------------------------------------------------------}
procedure SendByte(out :byte;var err:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
    begin
      reg.DX:=0;reg.AH:=1;reg.AL:=out;Intr($14,reg);
      repeat
        reg.AH:=2;Intr($14,reg);
      until reg.AH <>$e0;
      err:=reg.AL;
      if (err and $80) > 0 then err:=err or $FF00;
    end;
{-------------------------------------------------------------------------}

{-------------------------------------------------------------------------}
procedure RTPcom(comcode:com;par1:integer;var par2,par3:longint;
                 var err:integer);
  var
    nib,nob,n,i:integer;
    p4,p5:longint;
    code:byte;

    p4i:array[1..2]of integer absolute p4;
    p5i:array[1..2]of integer absolute p5;
  begin
    code:=Ord(comcode);RTPword[1]:=par1;i:=1;
    if code=13 then i:=2;
    if code in [13,16,17,30,35..37] then
      begin
        RTPword[i+1]:=par2 and $FFFF;RTPword[i  ]:=par2 shr 16;
        RTPword[i+3]:=par3 and $FFFF;RTPword[i+2]:=par3 shr 16;
      end;
    if code=37 then RTPword[3]:=par1;
    case code of
      0..4,8..12,18,19,26..29 : nob:=2;
      13 : nob:=10;
      16,17,35 : nob:=8;
      30 : nob:=4;
      37 : nob:=6;
      36 : nob:=8;
      else nob:=0;
    end;
    n:=nob div 2;
    if nob>0 then begin
         for i:=1 to n do RTPword[i]:=Swap(RTPword[i]);
         for i:=nob downto 1 do RTPbyte[i+1]:=RTPbyte[i];
         end;
    RTPbyte[1]:=code; nob:=nob+1;i:=1;


    {tak jsou ulozeny vysilane byty na poli RTPword}


    {ted jeste urcim pocet prijimanych bytu ...... nib}

    case code of
      15,34  : nib:=2;
      22,23,38,39 : nib:=10;
      30 : nib:=4;
      31 : nib:=8;
      32 : nib:=12;
      33 : nib:=16;
      35 : nib:=par3-par2+1;
      else nib:=0;
    end;

    repeat
      SendByte(RTPbyte[i],err);
      if err<>0 then
        begin
          writeln(' ERROR of RTP N.',err:5,'  in command N.',code:3); exit;
        end;
      Inc(i);
    until i>nob;

    {ted pracuje RTP ..... a budou se cist vstupni data}

   {reg.DX:=0;}
    repeat
      reg.AH:=2;Intr($14,reg);
    until reg.AH <>$e0;
    if reg.AL<>0 then
      begin
        err:=reg.AL;if (err and $80) >0 then err:=err or $FF00;
        writeln(' ERROR of RTP N.',err:5,'  in command N.',code:3); exit;
      end;
    {reg.DX:=0;}
    if nib>0 then
    for i:=1 to nib do
      begin
        repeat
          reg.AH:=2;Intr($14,reg);
         until reg.AH <>$e0;
        RTPbyte[i]:=reg.AL;
      end;
    if nib>0 then
      begin
        n:=nib div 2;
        for i:=1 to n do RTPword[i]:=Swap(RTPword[i]);
        case code of
          30 : begin
                 p4i[2]:=RTPword[1];p4i[1]:=RTPword[2];par3:=p4;
               end;
          31 : begin
                 p4i[2]:=RTPword[1];p4i[1]:=RTPword[2];par2:=p4;
                 p5i[2]:=RTPword[3];p5i[1]:=RTPword[4];par3:=p5;
               end;
          15,22,23,32,34,38,39 : for i:=1 to n do
                                   RTPword[i]:=RTPword[i] and $FFF;
        end;
      end;
    if code=36 then
      begin
        nob:=par3-par2+1;for i:=1 to nob do SendByte(RTPmmm[i],err);
      end;
  end;      {RTPcom}

{--------------------------------------------------------------------------}
{--------------------------------------------------------------------------}



procedure RTP(comcode :com;par1:integer;var par2,par3:longint;
                                             var err:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}


  var
    sig,chn,cx,cy,i,nerr:integer;
    ind:array[1..5] of integer;
    n,p4,p5:longint;


  procedure WB(chn :integer);
  {xxxxxxxxxxxxxxxxxxxxxxxxxx}
    var k:integer;
        s:string[2];
        dr:extended;
    begin
      if slittype=1 then sss:='H' else sss:='C';
      Str(chn:1,s);measfilename:=platename+'.C'+sss+s;
      Assign(measfile,measfilename);
      if nsig[chn]=0 then begin
        Rewrite(measfile,2);
        if slittype=1 then
          case chn of
            1,5 : Blockwrite(measfile,compstep,1);
            2,4 : Blockwrite(measfile,fogstep,1);
            3   : Blockwrite(measfile,starstep,1);
          end
          else Blockwrite(measfile,calstep,1);
          end else begin
            Reset(measfile,2);Seek(measfile,FileSize(measfile)); end;
      dr:=3700.0/(light[chn]-dark[chn]);
      if slittype=1 then
        for k:=1 to ind[chn] do
          meas[chn,k]:=Round(dr*(meas[chn,k]-dark[chn]));
      BlockWrite(measfile,meas[chn,1],ind[chn]);Close(measfile);
      nsig[chn]:=nsig[chn]+ind[chn];ind[chn]:=0;
    end;  {WB}
  {-----------------------------------------------------------------}
  function Maxsig:integer;
  {xxxxxxxxxxxxxxxxxxxxxxx}
    var k:integer;
    begin
      RTPcom(LI,0,p4,p5,err);sig:=0;
      if slittype=2 then sig:=RTPword[1]
        else for k:=1 to 5 do if RTPword[k]>sig then sig:=RTPword[k];
      Maxsig:=sig;
    end;
  {-----------------------------------------------------------------}


  begin     {RTP}
    if not RTPinit then
      begin
        reg.DX:=0;reg.AH:=0;reg.AL:=$FB;Intr($14,reg);
          reg.AH:=2;Intr($14,reg);Delay(500);
        writeln(' Is it necessary to make encoder setting ? Y/N');
        if UpCase(ReadKey)='Y' then begin
        RTPcom(LPS,ON,p4,p5,err);
        RTPcom(DRIVE,ON,p4,p5,err);
        writeln('    RTP encoder setting ....');RTPcom(SENC,0,p4,p5,err);
        RTPcom(GXYC,0,p4,p5,err); end;
        RTPinit:=true;
      end;
    case comcode of
      DMM : begin
        p5:=par2-1;cx:=WhereX;cy:=WhereY;nerr:=0;
        for i:=1 to 5 do begin nsig[i]:=0;ind[i]:=0; end;
        repeat
          p4:=p5+1;p5:=p5+DMMSize;
          if p5>par3 then p5:=par3;
          RTPcom(DMM,0,p4,p5,err);n:=(p5-p4+1) div 2;
          for i:=1 to n do
            begin
              sig:=RTPword[i];chn:=(sig and $F000) shr 12;
              if (chn<1) or (chn>5) then Inc(nerr) else begin
                sig:=sig and $FFF;Inc(ind[chn]);meas[chn,ind[chn]]:=sig;
                if ind[chn]=measSize then WB(chn);end;
            end;
          GoToXY(cx,cy);n:=(p5-par2+1) div 2;write(n:7,nerr:3,' errors');
        until p5=par3;
        for chn:=1 to 5 do
          if ind[chn]>0 then WB(chn);

        end;
      SLPM,SLFOG : begin
        repeat
          sig:=Maxsig;
          case sig of
            0..1000 : par1:=-200;
            1001..2000 : par1:=-100;
            2001..2700 : par1:=-50;
            2701..3100 : par1:=-30;
            3101..3400 : par1:=-15;
            3401..3600 : par1:=-8;
            3601..3670 : par1:=-4;
            3670..3700 : par1:=-1;
            3750..3800 : par1:=3;
            3800..3900 : par1:=5;
            3901..4000 : par1:=10;
            4001..4095 : par1:=100;
            else par1:=0;
          end;
          RTPcom(LLCN,0,p4,p5,err);if RTPword[1]=0 then par1:=0;
          if par1<>0 then RTPcom(SLCN,par1,p4,p5,err);Delay(500);
        until par1=0;
        RTPcom(comcode,par1,par2,par3,err);
        if (err=1) and (slittype=2) then begin
         RTPcom(SANOR,0,par2,par3,err);RTPcom(SAPM,0,par2,par3,err);end;
        end;

    else RTPcom(comcode,par1,par2,par3,err);
    end;   {of case}

(*    if err<>0 then begin
      Append(cfile);GetTime(hour,minute,sec,sec100);sig:=Ord(comcode);
      writeln(cfile,hour:5,minute:3,sec:3,'   error N.',err:5,
              '  in comand N.',sig:3);Close(cfile);end;
*)
    if (err<0) or (err=3) then begin
      writeln('  RTP in OFF-Line ! ');
(*      Append(cfile);
      for i:=1 to 60 do write(cfile,'@');writeln(cfile);
      writeln(cfile,' negative error, RTP in OFF-Line, test broken');
      for i:=1 to 60 do write(cfile,'@');writeln(cfile);
*)      writeln('Press any key to stop sound and program!');
      Sound(800);while not KeyPressed do ;
      NoSound;Halt;end;

  end;    {RTP}

  {------------------------------------------------------------------------}
  {------------------------------------------------------------------------}


procedure XtPlot(filename:string;i1,i2:longint;disp:integer);
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

{i1,i2 : 1..FileSize    i1=0..od zacatku   i2=0..do konce  souboru}

var
  i,j,err:integer;
  n,p2,p3:longint;

begin
  Assign(measfile,filename);Reset(measfile,2);n:=FileSize(measfile);
  Dec(i1);if i1<0 then i1:=0;
  Seek(measfile,i1);
  if i2=0 then i2:=n; Dec(i2); if i2>=n then i2:=n-1;
  BlockRead(measfile,j,1);

  {ted je i1,i2 : 0..FileSize-1}

  RTPmmm[1]:=0;RTPmmm[2]:=255;RTPmmm[3]:=0;RTPmmm[4]:=1;
  RTPmmm[5]:=j shr 4; p2:=0;p3:=4;RTP(MMM,0,p2,p3,err);

  {to byl posuv pera na zacatek}

  Inc(i1);n:=1;    {n......pocet bloku}
  RTPmmm[1]:=8;RTPmmm[2]:=disp;
  repeat
    i:=4;
    repeat
      BlockRead(measfile,j,1);Inc(i);RTPmmm[i]:=j shr 4;Inc(i1);
    until (i=RTPmmmSize) or (i1>i2);
    j:=i-4;RTPmmm[3]:=Hi(j);RTPmmm[4]:=Lo(j);p2:=p3+1;p3:=p3+i;
    RTP(MMM,0,p2,p3,err);Inc(n);
  until i1>i2;
  RTPmmm[1]:=0;RTPmmm[2]:=255;RTPmmm[3]:=0;RTPmmm[4]:=1;RTPmmm[5]:=0;
  p2:=p3+1;p3:=p3+5;RTP(MMM,0,p2,p3,err);Inc(n);p2:=0;
  RTP(XT,n,p2,p3,err);

end;    {XtPlotu}

{--------------------------------------------------------------------}

begin
  RTPinit:=false;
  for i:=1 to 5 do begin
    light[i]:=3700;dark[i]:=0;end;
(*
  GetDate(rok,mes,den,dent);GetTime(hour,minute,sec,sec100);
  cfname:='c:\spefo\test';Str(den:2,sss);if sss[1]=' ' then sss[1]:='0';
  cfname:=cfname+sss;Str(mes:2,sss);if sss[1]=' ' then sss[1]:='0';
  cfname:=cfname+sss+'.LOG';
  FindFirst(cfname,AnyFile,srec);Assign(cfile,cfname);
  if DosError<>0 then begin
    Rewrite(cfile);writeln(cfile,'  Test-log of',den:5,mes:3,'   begins at',
                            hour:5,minute:3,sec:3);end
    else begin Append(cfile);
    writeln(cfile,'  Test continues at',hour:5,minute:3,sec:3);
    Close(cfile);end;
*)
end.